import { ITemplateReader } from "./_definitions/ITemplateReader";
import { IComponentFileInfo, ITemplateExtractor } from "./_definitions/ITemplateExtractor";
import { ITemplateConfigFile } from "./_definitions/ITemplateConfigFile";
declare type compWrkDir = ITemplateConfigFile['componentWorkDir'];
export declare class TemplateExtractor implements ITemplateExtractor {
    templateReader: ITemplateReader;
    replaceVal: string;
    subdomain?: string | undefined;
    constructor(templateReader: ITemplateReader, replaceVal: string, subdomain?: string | undefined);
    getComponentDirName(): string;
    getComponentFiles(componentWrkDir: string): Promise<IComponentFileInfo[] | Error>;
    getComponentWrkDirPath(componentWrkDir: compWrkDir): string | Error;
    private _changeFileContent;
    private _getConvention;
    private _getAllConventions;
    private _buildClassicRegex;
    private _buildSuperRegex;
    private _transformPaths;
}
export {};
