"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorMsgs = void 0;
const path_1 = __importDefault(require("path"));
const config_1 = require("./config");
const CommandEnum_1 = require("./CommandEnum");
const chalk_1 = __importDefault(require("chalk"));
const table_1 = require("table");
const provide_valid_stuff = (stuff) => `Vous devez fournir ${chalk_1.default.underline(stuff)} dans le fichier de configuration "${(0, config_1.cInfo)(config_1.nameConfigFile)}" du composant`;
const unable_create_component = (0, config_1.cErr)("Impossible de créer votre composant");
const contact_creator_unexpected_error = (0, config_1.cInfo)("Afin que le problème soit résolut, veuillez contacter le créateur du module");
exports.ErrorMsgs = {
    UNEXPECTED_ERR(pendant, err) { return `${(0, config_1.cWarning)("Une erreur inattendue s'est produite pendant " + pendant)}:\n${(err === null || err === void 0 ? void 0 : err.message) ? err.message : err} \n ${contact_creator_unexpected_error}`; },
    UNEXPECTRED_FILE_CREATION_ERR: (fileName, err) => `${(0, config_1.cWarning)("Une erreur inattendue s'est produite")} pendant la création du fichier "${(0, config_1.cWarning)(fileName)}" : 
${(err === null || err === void 0 ? void 0 : err.message) ? err.message : err} \n${contact_creator_unexpected_error}`,
    UNEXPECTRED_DIRECTORY_CREATION_ERR: (dirName, err) => `${(0, config_1.cWarning)("Une erreur inattendue s'est produite")} pendant la création du répertoire "${(0, config_1.cWarning)(dirName)}" : 
${(err === null || err === void 0 ? void 0 : err.message) ? err.message : err} \n ${contact_creator_unexpected_error}`,
    UNEXPECTRED_EXAMPLE_TEMPLATE_CREATION_ERR: (0, config_1.cInfo)("OOPS ! Impossible de générer le template d'exemple !"),
    DUPLICATE_TEMPLATE_NAME: (dupliName, paths) => {
        const formatedPaths = paths.map(path => [`${(0, config_1.cWarning)(path)}`]);
        return `Attention vous avez des templates ayant le même nom "${(0, config_1.cErr)(dupliName)}" \n${(0, table_1.table)(formatedPaths)}`;
    },
    CONFIG_DIR_MISS: ` 
  ${(0, config_1.cWarning)("Dossier de configuration manquant: ")}Le dossier de configuration ${config_1.cInfo.underline("/" + config_1.nameConfigDir)} n'as pas été trouvé !
  Il doit être placé à la racine de votre projet. 
  ${(0, config_1.cInfo)("Executez la commande:")} "${chalk_1.default.green.bgWhite("$", config_1.CLIAccess, chalk_1.default.bold(CommandEnum_1.CommandEnum.init))}" pour initialiser le CLI automatiquement
`,
    CONFIG_FIlE_MISS: (tempName) => `${(0, config_1.cWarning)("Fichier de configuration manquant")} : Vous devez ajouter le fichier de configuration ${config_1.cInfo.underline(config_1.nameConfigFile)} au template "${(0, config_1.cWarning)(tempName)}"`,
    PROJECT_PATH_INVALID_VALUE: (errPath) => `${(0, config_1.cWarning)("Propriété invalide dans le fichier config du template:")} Le chemin '${(0, config_1.cWarning)(errPath)}'  de la pté ${(0, config_1.cInfo)("componentWorkDir")} est incorrect car vous avez fourni ${(0, config_1.cErr)("un chemin absolut")} 
  Vous devez fournir un chemin ${chalk_1.default.underline("relatif")} à ${(0, config_1.cInfo)("la racine de votre projet")}`,
    ROOT_PATH_INVALID_VALUE: (errPath) => `${(0, config_1.cWarning)("Propriété invalide dans le fichier config du template:")} Le chemin '${(0, config_1.cWarning)(errPath)}'  de la pté ${(0, config_1.cInfo)("componentWorkDir.rootWorkDir")} est incorrect car vous avez fourni ${(0, config_1.cErr)("un chemin absolut")} 
  Vous devez fournir un chemin ${chalk_1.default.underline("relatif")} à ${(0, config_1.cInfo)("la racine de votre projet")}`,
    EXTENTION_PATH_INVALID_VALUE: (errPath) => `${(0, config_1.cWarning)("Propriété invalide dans le fichier config du template:")} Le chemin '${(0, config_1.cWarning)(errPath)}' de la pté ${(0, config_1.cInfo)("componentWorkDir.extensionWorkDir")} est incorrect car vous avez fourni ${(0, config_1.cErr)("un chemin absolut")} 
  Vous devez fournir un chemin ${chalk_1.default.underline("relatif")} à la pté ${(0, config_1.cInfo)("componentWorkDir.rootWorkDir")}`,
    SUBDOMAIN_PATH_INVALID_VALUE: (errPath) => `${(0, config_1.cWarning)("Valeur d'option invalide:")} Le chemin '${(0, config_1.cWarning)(errPath)}' de l'option ${(0, config_1.cInfo)("--subdomain")} est incorrect car vous avez fourni ${(0, config_1.cErr)("un chemin absolut")} 
  Vous devez fournir un chemin ${chalk_1.default.underline("relatif")} à la pté ${(0, config_1.cInfo)("componentWorkDir")} |  ${(0, config_1.cInfo)("componentWorkDir.rootWorkDir")} `,
    TEMPLATE_NOT_EXIST: (tempName) => `Vous n'avez pas de template nommé "${(0, config_1.cErr)(tempName)}"`,
    COMPONENT_WRK_DIR_NOT_EXISTE: (compPath) => `${unable_create_component} car l'emplacement "${(0, config_1.cWarning)(compPath)}" n'existe pas. \n ${provide_valid_stuff("un path valide")}`,
    ROOT_WRK_DIR_NOT_EXISTE: (rootPath) => `${unable_create_component} car ${chalk_1.default.bold.underline("le répertoire de travail racine")} "${rootPath}" n'existe pas dans votre projet ${path_1.default.resolve()}. \n ${provide_valid_stuff("un répertoire racine")}`,
    SUBDOMAIN_PATH_NOT_EXISTE: (subName, rootPath) => `${unable_create_component} car ${chalk_1.default.bold.underline("le sous-répertoire ")} "${subName}" n'existe pas dans "${rootPath}". \n ${provide_valid_stuff("un nom de sous-domaine")}`,
    EXTENTION_WRK_DIR_NOT_EXISTE: (extPath, subPath) => `${unable_create_component} car ${chalk_1.default.bold.underline("l'extention")} "${extPath}" n'existe pas dans le sous-domaine "${subPath}". \n ${provide_valid_stuff("une extention valide")}`,
    CONFIG_FILE_INVALID: (pty, types) => `${(0, config_1.cWarning)("Fichier de configuration invalide: ")} : Le fichier de configuration de votre template doit contenir la pté "${(0, config_1.cInfo)(pty)}" de type ${(0, config_1.cSuccess)(types)}`,
    COMPONENT_ALREADY_EXIST: (dirName, wrkPath) => `Impossible de créer le composant "${(0, config_1.cInfo)(dirName)}" car ${(0, config_1.cWarning)("un composant du même nom existe déjà à cet emplacement")} (${wrkPath})`,
    CACHE_UNEXPECTED_INCONSISTENCY: (0, config_1.cErr)(`Un problème inattendu de est survenue pendant la vérification de cohérence du cache : ${(0, config_1.cErr)("Impossible d'établir de cohérence entre le contenu du cache et celui des templates !")} `),
};
//# sourceMappingURL=ErrorMsgs.js.map