"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.list = void 0;
const TemplateRepository_1 = require("../TemplateRepository");
const config_1 = require("../_constantes/config");
const table_1 = require("table");
const chalk_1 = __importDefault(require("chalk"));
const InfoMsgs_1 = require("../_constantes/InfoMsgs");
const config = {
    drawHorizontalLine: (lineIndex, rowCount) => {
        return lineIndex === 0 || lineIndex === 1 || lineIndex === rowCount;
    },
    columns: [
        { alignment: 'center' },
        { alignment: 'center' },
        { alignment: 'center' },
    ],
    border: (0, table_1.getBorderCharacters)("norc")
};
const list = () => __awaiter(void 0, void 0, void 0, function* () {
    const tempMetaDataResult = yield TemplateRepository_1.TemplateRepo.getAllMetadata();
    if (tempMetaDataResult instanceof Error)
        return console.log(tempMetaDataResult.message);
    const datTable = tempMetaDataResult.map(({ configFile }) => {
        const tempName = configFile.template;
        let wrkDirectory;
        let extensionDirectory = "none";
        if (typeof configFile.componentWorkDir === "string")
            wrkDirectory = configFile.componentWorkDir;
        else {
            wrkDirectory = configFile.componentWorkDir.rootWorkDir;
            if (configFile.componentWorkDir.extensionWorkDir)
                extensionDirectory = configFile.componentWorkDir.extensionWorkDir;
        }
        return [chalk_1.default.bold(tempName), (0, config_1.cSuccess)(wrkDirectory), (0, config_1.cSuccess)(extensionDirectory)];
    });
    datTable.unshift(["Name", "Working Directory", "Extension Working Directory"]);
    if (datTable.length > 1) {
        const formatedTable = (0, table_1.table)(datTable, config);
        console.log(formatedTable);
    }
    else
        console.log((0, table_1.table)([[InfoMsgs_1.InfoMsgs.NO_TEMPLATE]]));
});
exports.list = list;
//# sourceMappingURL=List.js.map